function center = initkm(cluster_n, data)
% INITKM Find the initial centers for a K-means clustering algorithm. 

% Roger Jang, 1998-5-18

% ====== Method 1: Randomly pick cluster_n data points as cluster centers
data_n = size(data, 1);
tmp = randperm(data_n);
index = tmp(1:cluster_n);
center = data(index, :);

% ====== Method 2: Choose cluster_n data points closest to the mean vector
%mean_vec = mean(data);
%dist = vecdist(mean_vec, data);
%[a,b] = sort(dist);
%center = data(b(1:cluster_n), :);

% ====== Method 3: Choose cluster_n data points furthest to the mean vector
%mean_vec = mean(data);
%dist = vecdist(mean_vec, data);
%[a,b] = sort(dist);
%b = fliplr(b);
%center = data(b(1:cluster_n), :);
