function G = findGamma(Y,AllS,Mue,num,Theta,sig,grid,clNum,c);

% Y - Y a matrix, each column corresponds to a gene.
% AllS - Collection of matrices for each gene
% Gamma - Matrix of the currently estimated Gammas
% X - indicates to which class the gene belongs
% Theta - the covariance matrix
% sig - the variance
% Mue - Class averages
% grid - the numbewr of grid points
% clNum - number of classes
% prob - the probabilty for each class

G = zeros(grid,num);
T1 = zeros(grid,grid,clNum);
for i=1:clNum,
  T1(:,:,i) = Theta(:,:,i)^(-1);
end 
[r,cols] = size(AllS(:,:,1));
Idt = diag(ones(r,1)*sig,0);
for i=1:num,
  curS = AllS(:,:,i);
  G(:,i) = Theta(:,:,c(i))*curS'*(curS*Theta(:,:,c(i))*curS' + Idt)^(-1) ...
            * (Y(:,i)-curS*Mue(:,c(i)));
end
