function err = confBandArea_GCV_AL(filename, sigma, allTimes)
% loads the output file and reads the following values from that
% finalT, numCntrlPts, numFinalSamples
% IN: 
%  filename: the .mat file with all the saved variables
%  sigma: the sigma umm... if you did save it in the file, just be nice and re-read it
%  allTimes: all possible sampling times. also see "sigma"
% OUT:
%  err: the actual error, as per confBandArea_GCV_AL

if (nargin==1)
  sigma = 0.2;
  allTimes = 1:24;
end

x = load(filename);
Tidx = x.finalT;
K = x.numCntrlPts;
n = x.numFinalSamples;

S = getS( allTimes(Tidx), K);
A = S * pinv(S);

err = 0;
for i=1:n-1
  ci1 = CI( A(i,i), sigma);
  ci2 = CI( A(i+1,i+1), sigma);
  err = err + (ci1+ci2)*0.5*( allTimes(Tidx(i+1)) - allTimes(Tidx(i)) );
end


