% for the paper. for sim data for ErrThreshold. only use dataA, dataE, dataI
load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};
dQual     = {'Easy','Hard','Easy','Moderate','Moderate','Moderate','Hard'};
trueErrThreshold = 0.15;

figure;

doTrueErrVsGcvError=1;
i=1;
for j=[1 4 2]%length(dSets)

  [dPlotMat, rPlotMat, dStopAt, rStopAt] = ...
      test4_anlyz_trueErrvsTimePts(j,trueErrThreshold);

  if (doTrueErrVsGcvError)
    subplot(1,3,i);
    %BEGIN true error vs timepoints
    err_desc='Error Measure = Conf. Area using GCV CIs';

    [dIdx,dTrueErr,dErrMetric,rIdx,rTrueErr,rErrMetric] = ...
	test4_anlyz_trueErrvsErrMetric(j, trueErrThreshold, dPlotMat, rPlotMat, dStopAt, rStopAt, err_desc);
    
    err_min =min([dErrMetric rErrMetric])-0.3;
    err_max =err_min+3;

    [a, sortR1] = sort(rTrueErr);
    [b, sortD1] = sort(dTrueErr);
    sortD = sortD1(end:-1:1);
    sortR = sortR1(end:-1:1);
    plot(dErrMetric(sortD),dTrueErr(sortD),'ko-',rErrMetric(sortR),  rTrueErr(sortR),'r*-',dErrMetric(sortD),dTrueErr(sortD),'ko',rErrMetric(sortR),rTrueErr(sortR),'r*');
    v = axis;
    ymin = min([dTrueErr rTrueErr]) -0.02;
    axis([err_min err_max  0.05 0.35]);
    %axis([err_max err_min  ymin 0.35]);
    v = axis;
    
    hold on;
    plot([v(1) v(2)],[trueErrThreshold trueErrThreshold],'g--');
    
    v= axis;
    lD = 1:length(dTrueErr);
    xD = max(dErrMetric(lD(dTrueErr<=trueErrThreshold)));
    lR = 1:length(rTrueErr);
    xR = max(rErrMetric(lR(rTrueErr<=trueErrThreshold)));  
    
    %plot([xD xD], [v(3) v(4)], 'k-.');
    %plot([xR xR], [v(3) v(4)], 'r-.');  
    
    hold off;
    if (j==1) 
      ylabel('True Error','FontSize', 11,'FontWeight','bold');
    end
    if (j==4)
      xlabel('GCV-error','FontSize', 11,'FontWeight','bold');
    end
    [LEGH,OBJH,OUTH,OUTM] = legend('ActiveLearn','Random');
    set(LEGH,'FontSize', 10);
    
    s=sprintf('%s',dQual{j});
    title(s,'FontSize', 11,'FontWeight','bold');  
    end
  
  
  %figname = sprintf('test4_2in1_gcverror_%s.tiff',dSetNames{j});
  %print(gcf, '-dtiff',figname);
  %figure;
i = i+1;
end
exportfig(gcf,'sim_et_figs2.eps','width',4.5,'height',3,'Color','cmyk')
%close;


