function test1b_visualize(data,gcvFile,lcvnaiveFile,lcvsmartFile,dataName, colTitles,figTitle)

gcvS = load(gcvFile);
lcvnaiveS = load(lcvnaiveFile);
lcvsmartS = load(lcvsmartFile);


if (size(data,1) ~= 150 | size(data,2) ~= 24)
  error('Need 150 genes x 24 expmts');
end
numGenes = 150;
N=24;
sigma = 0.2;
errMagnify = 10;

cl1 = 1:50;
cl2 = 51:100;
cl3 = 101:150;

%in each cluster we pick about 10 samples to just draw in background.
%these 10 are their indices
rndprm1 = randperm(50); %50 elmts per cluster
idx1 = rndprm1(10);

Cols = 5;

%4xCols matrix of figures 
% first col is ideal i.e. real function used
% 2nd col is gcv
% 3rd col is lcvNaive
% 4th col is lcvSmart
% last col is actual i.e. using all timepointsreal function used


%plot ideal

% 1st row, 1st col is empty
idealBG = [1 1 0.6]; %light yellow
%sphdl = subplot(4,Cols,1);
%hold on;
%set(sphdl,'Color',idealBG);

% 2nd row, 1st col is cluster1
sphdl = subplot(4,Cols,Cols+1);
d1 = data(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;
set(sphdl,'Color',idealBG);

% 3rd row, 1st col is cluster 2
sphdl = subplot(4,Cols,2*Cols +1);
d2 = data(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;
set(sphdl,'Color',idealBG);

% 3rd row, 1st col is cluster 3
sphdl = subplot(4,Cols,3*Cols+1);
d3 = data(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;
set(sphdl,'Color',idealBG);


%fix axes:
a11 = [1 2 3]*Cols + 1;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end

%plot ideal done


%plot best data
allTimes = 1:N;%[1:2:N-1 N];
%[bestC1,bestC2,bestNa] = contRep(data(:,allTimes),data(:,allTimes),allTimes,allTimes,gcvS.numCntrlPts-2, 3);
bestC1 = gcvS.C1;
bestNa = gcvS.Na;

bErr = abs(bestC1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,gcvS.numCntrlPts);
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sigma;

% 1st row, 5th col is empty
bestBG = [0.9 0.9 1]; %purplish
clear d1, t1;

sphdl = subplot(4,Cols,Cols);
title('With all samples','FontSize',11,'FontWeight','bold')
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
for i=1:N
  plotErrorBar(i,0,bci1(i),'r',1);
end
set(sphdl,'Color',bestBG);


% 2nd row, 5th col is cluster1
sphdl = subplot(4,Cols,2*Cols);
d1 = bestC1(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;
set(sphdl,'Color',bestBG);

% 3rd row, 5th col is cluster 2
sphdl = subplot(4,Cols,3*Cols);
d2 = bestC1(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;
set(sphdl,'Color',bestBG);

% 3rd row, 5th col is cluster 3
sphdl = subplot(4,Cols,4*Cols);
d3 = bestC1(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;
set(sphdl,'Color',bestBG);

%fix axes:
a11 =[2 3 4]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,Cols);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=Cols*[1 2 3 4]
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = gcvS.numCntrlPts;
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = Cols*[2 3 4];
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=allTimes
    plot([i i],[ymin tx(j,i)],'m');
  end 
end



%plot gcv data
bErr = abs(gcvS.C1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,gcvS.numCntrlPts);
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 2nd col is empty


sphdl = subplot(4,Cols,2);
% plot errors
title(colTitles{1},'FontSize',11,'FontWeight','bold');
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,gcvS.finalCI(i)/ max(size(gcvS.finalT)),'r',1); %bci1(i),'r',1);
%end



% 2nd row, 2nd col is cluster1
sphdl = subplot(4,Cols,2+Cols);
d1(:,:) = gcvS.gcvC1(end,cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 2nd col is cluster 2
sphdl = subplot(4,Cols,2+2*Cols);
d2(:,:) = gcvS.gcvC1(end,cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 2nd col is cluster 3
sphdl = subplot(4,Cols,2+3*Cols);
d3(:,:) = gcvS.gcvC1(end,cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 2+Cols*[1 2 3];
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,1+1);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=2+ [ 1 2 3]*Cols
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = gcvS.numCntrlPts;
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 2;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=1:max(size(gcvS.finalT))
    plot([gcvS.finalT(i) gcvS.finalT(i)], [ymin tx(j,gcvS.finalT(i))],'m');
  end 
end



%plot lcv-naive data
bErr = abs(lcvnaiveS.C1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,lcvnaiveS.numCntrlPts);
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 3rd col is empty


sphdl = subplot(4,Cols,3);
title(colTitles{2},'FontSize',11,'FontWeight','bold');
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,lcvnaiveS.finalCI(i)/ max(size(lcvnaiveS.finalT)),'r',1); %bci1(i),'r',1);
%end


% 2nd row, 3rd col is cluster1
sphdl = subplot(4,Cols,3+1*Cols);
d1(:,:) = lcvnaiveS.gcvC1(end,cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 2
sphdl = subplot(4,Cols,3+2*Cols);
d2(:,:) = lcvnaiveS.gcvC1(end,cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 3
sphdl = subplot(4,Cols,3+3*Cols);
d3(:,:) = lcvnaiveS.gcvC1(end,cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 3+ [1 2 3]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,3);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=[ 1 2 3]*Cols + 3;
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = lcvnaiveS.numCntrlPts;
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 3;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=1:max(size(lcvnaiveS.finalT))
    plot([lcvnaiveS.finalT(i) lcvnaiveS.finalT(i)], [ymin tx(j,lcvnaiveS.finalT(i))],'m');
  end 
end



%plot lcv-smart data
bErr = abs(lcvsmartS.C1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,lcvsmartS.numCntrlPts);
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 3rd col is empty


sphdl = subplot(4,Cols,4);
title(colTitles{3},'FontSize',11,'FontWeight','bold');
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,lcvsmartS.finalCI(i)/ max(size(lcvsmartS.finalT)),'r',1); %bci1(i),'r',1);
%end


% 2nd row, 3rd col is cluster1
sphdl = subplot(4,Cols,4+1*Cols);
d1(:,:) = lcvsmartS.gcvC1(end,cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 2
sphdl = subplot(4,Cols,4+2*Cols);
d2(:,:) = lcvsmartS.gcvC1(end,cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 3
sphdl = subplot(4,Cols,4+3*Cols);
d3(:,:) = lcvsmartS.gcvC1(end,cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 4+ [1 2 3]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,4);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=[ 1 2 3]*Cols + 4
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = lcvsmartS.numCntrlPts;
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 4;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=1:max(size(lcvsmartS.finalT))
    plot([lcvsmartS.finalT(i) lcvsmartS.finalT(i)], [ymin tx(j,lcvsmartS.finalT(i))],'m');
  end 
end


%fix y-limits for the top row
a11 = 2:Cols;
for i=1:max(size(a11))
  sphdl = subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -0.75 0.75]);
  set(sphdl,'XTickLabels','');
  set(sphdl,'YTickLabels','');
end

figure(gcf);
gtext(['For dataset ' dataName ' with ' figTitle],'FontSize', 11,'FontWeight','bold');
