%TO: 50 random matrices, each for data A/B/D/E with 12 pts, get gcv and
%lcv cntrl points (and scores) for each. save in a file

global topLevelCost;
global DEBUG;

DEBUG = 3;
load SimData;

dataSources = {'dataA' , 'dataB', 'dataC', 'dataD', 'dataE', 'dataF'};
dataS(1,:,:) = dataA;
dataS(2,:,:) = dataB;
dataS(3,:,:) = dataC;
dataS(4,:,:) = dataD;
dataS(5,:,:) = dataE;
dataS(6,:,:) = dataF;

startT = [1 6 12 18 24]';
numInitial = max(size(startT));
allTimes = (1:24)';
numFinalSamples = 12;
classes = 3;
numRandomTries = 50;

for i=[1 2 4 5]
  saveFileName = ['test2_rnd_' dataSources{i}]
  
  all_finalT = zeros(numRandomTries, numFinalSamples);
  all_gcvScore = zeros(1,numRandomTries); 
  all_lcvScore = zeros(1,numRandomTries);
  all_gcvNumCntrlPts = zeros(1,numRandomTries);
  all_lcvNumCntrlPts = zeros(numRandomTries, numFinalSamples);
  
  D(:,:) = dataS(i,:,:);
  [numGenes, numTotalSampled] = size(D);

  initialN = length(startT);
  
  idxs = setdiff(1:numTotalSampled, startT);
  r = length(idxs);
  R = numFinalSamples - initialN;
  
  for k=1:numRandomTries
    x1 = randperm(r);
    x2 = idxs(x1(1:R))
    x3 = [x2'; startT];
    sT = sort(x3);
    all_finalT(k,:) = sT';
    
    %do gcv and get gcv score
    [gcvI, Agcv, C1gcv, C2gcv, Na_gcv, gcvScore, sig, gcv_alli, gcv_allC1, gcv_allNa, gcv_allSig] = findLambdaG(D, sT, allTimes, classes);
    
    all_gcvNumCntrlPts(k) = gcvI;
    gcvscore = 0;
    for j=1:(numFinalSamples-1)
      ci1 = CI( Agcv(j,j), sqrt(sig));
      ci2 = CI( Agcv(j+1,j+1), sqrt(sig));
      gcvscore = gcvscore + (ci1+ci2) * 0.5 * (allTimes(sT(j+1)) - allTimes(sT(j)));
    end
    all_gcvScore(k) = gcvscore;
    all_gcvNumCntrlPts(k) = gcvI;
    
    
    %do lcv and get lcv score
    [lcvCntrlPts, lcv_Scores] = lcv(D, sT, allTimes, gcvI, gcv_alli, gcv_allC1, gcv_allNa);
    CIlcv = ones(1, length(allTimes)) * -1;
    
    for j=1:length(sT)
      s_j = getS( allTimes(sT), lcvCntrlPts(j));
      A_j = s_j * pinv(s_j);
      CIlcv(sT(j)) = CI(A_j(j,j), sqrt(sig));
    end
    
    lcvscore = 0;
    for j=1:(length(sT)-1)
      ci1 = CIlcv( sT(j) );
      ci2 = CIlcv( sT(j+1) );
      lcvscore = lcvscore + (ci1+ci2) * 0.5 * (allTimes( sT(j+1) ) - ...
					       allTimes( sT(j) ));
    end
    all_lcvScore(k) = lcvscore;
    all_lcvNumCntrlPts(k,:) = lcvCntrlPts;
  end

  save( saveFileName, 'all_finalT', 'all_gcvScore', 'all_lcvScore', 'all_gcvNumCntrlPts', 'all_lcvNumCntrlPts');

end
