%TO: for strat={gcv, lcv, gcv-activelearning, lcv-activelearning},  for
%data A/B/D/E with 12 pts, for cost = {0.8, 0.9, 1.0}: get gcv and lcv
%cntrl points (and scores) for each. save in a file.

global topLevelCost;
global DEBUG;

DEBUG = 3;
load SimData;

dSets = {dataA, dataB, dataD, dataE};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE'};

costs = [0.8, 0.9, 1.0];
costNames = {'0_8', '0_9', '1_0'};

strats = {'gcv', 'lcv-smart', 'gcv-activelearning', 'lcv-activelearning'};
stratTitles = {'gcv','lcv','gcv+al','lcv+al'};

numInitial = 5;
numFinalSamples = 12;
allTimes = (1:24)';
classes = 3;

for i=1:length(costs)
  for j=1:length(dSets)
    for k=1:length(strats)
      gcvNumCntrlPts = 0;
      lcvNumCntrlPts = zeros(1,numFinalSamples);
      gcvScore = 0;
      lcvScore = 0;
      
      D = dSets{j};
      dN = dSetNames{j};
      fname = [ '27sep3pm_' dN '_st' int2str(numInitial) '_end' ...
		int2str(numFinalSamples) '_' strats{k} '_c_' costNames{i} ]
      dname = ['test2_' dN '_' strats{k} '_c_' costNames{i} '_scores']
      
      F = load(fname);
      sT = F.finalT;
      
      %do gcv and get gcv score
      [gcvI, Agcv, C1gcv, C2gcv, Na_gcv, gcvScore, sig, gcv_alli, gcv_allC1, gcv_allNa, gcv_allSig] = findLambdaG(D, sT, allTimes, classes);
      
      gcvscore = 0;
      for r=1:(numFinalSamples-1)
	ci1 = CI( Agcv(r,r), sqrt(sig));
	ci2 = CI( Agcv(r+1,r+1), sqrt(sig));
	gcvscore = gcvscore + (ci1+ci2) * 0.5 * (allTimes(sT(r+1)) - allTimes(sT(r)));
      end
      
      gcvNumCntrlPts = gcvI;
      gcvScore = gcvscore;
      
      %do lcv and get lcv score
      [lcvCntrlPts, lcv_Scores] = lcv(D, sT, allTimes, gcvI, gcv_alli, gcv_allC1, gcv_allNa);
      CIlcv = ones(1, length(allTimes)) * -1;
      
      for r=1:length(sT)
	s_r = getS( allTimes(sT), lcvCntrlPts(r));
	A_r = s_r * pinv(s_r);
	CIlcv(sT(r)) = CI(A_r(r,r), sqrt(sig));
      end
      
      lcvscore = 0;
      for r=1:(length(sT)-1)
	ci1 = CIlcv( sT(r) );
	ci2 = CIlcv( sT(r+1) );
	lcvscore = lcvscore + (ci1+ci2) * 0.5 * (allTimes( sT(r+1) ) - ...
						 allTimes( sT(r) ));
      end
      lcvNumCntrlPts = lcvCntrlPts;
      lcvScore = lcvscore;
      
      save(dname, 'gcvNumCntrlPts', 'lcvNumCntrlPts','gcvScore', 'lcvScore');
    end
  end
end
