%TO: for datasets={dataA/dataB/dataD/dataE} find 12 uniformly sampled
%time points {1 3 6:2:24} and find optimal clustering using gcv. then
%finely sample it to 150x231 resolution. save.


global topLevelCost;
global DEBUG;
topLevelCost = 1;
DEBUG = 3;

load SimData;

dSets = {dataA, dataB, dataD, dataE};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE'};

maxPoints = 231;

uniT = [1 3 6:2:24]'
allTimes = [1:24]';
classes = 3;
for j=1:length(dSets)
  dN = dSetNames{j};

  [i, A, C1, C2, Na, gcvScore, sig, gcv_alli, gcv_allC1, gcv_allNa, gcv_allSig] = findLambdaG(dSets{j}, uniT, allTimes, classes);
  numCntrlPts = i;
  
  est = test3_fillInEstimate( dSets{j}, allTimes(uniT), classes, Na, ...
			      numCntrlPts, maxPoints);
  fname = ['test3_unif_fine_' dN];
  save(fname, 'numCntrlPts', 'C1', 'Na', 'est', 'classes', 'uniT', ...
       'allTimes', 'classes');
end
