function est = test3_fillInEstimate(D, t, classes, inNa, numCntrlPts, newNumTimePoints)
% [est] = test3_fillInEstimate(D, T, inNa, classes, numCntrlPts, newNumTimePoints)
% given D with prior clustering and interpolation, redo the
% calculations to get more fine-grained sampling
%
% IN:
% D: numGenes x numTotalSampled
% t: 1x numCurrentlySampled. t(1) =1 and t(end) = numTotalSampled
% classes: number of clusters
% inNA: clustering discovered previously
% numCntrlPts: the number of control points to be used for clustering
% newNumTimePoints: the total number of points where the splines need
% to be evaluated.
% OUT:
% est: numGenes x newNumTimePoints

global DEBUG;

if (t(1) ~= 1 & (t(end) ~= size(D,2)))
  error('Bad inputs');
end

allTimes = 1:24;
T = allTimes(t);

newDivnsPerOld =  (newNumTimePoints-1) / (T(end)-1);
m = newDivnsPerOld;
f = 1.0/ m;
rf =(m-1)*f;

p1 = path;
p1 = path(p1,'ziv/ContRep/contRep');
p1 = path(p1,'ziv/ContRep/contWithKnownClasses');

Nv1 = D(:,T);
%time1 = T;
time1 = (T-1)*m + 1;
grid = numCntrlPts - 2;
[eps,temp] = size(Nv1);

if (DEBUG==1)
  [Tht,inp,avg,Gamma,sig] = interK(Nv1,inNa,grid,eps,time1,1,'data2');
else 
  if (DEBUG==2)
    [Tht,inp,avg,Gamma,sig] = interK(Nv1,inNa,grid,eps,time1,5,'data2');
  else
    [Tht,inp,avg,Gamma,sig] = interK(Nv1,inNa,grid,eps/2,time1,5,'data2');
  end
end
tot1 = length(time1);
np1 = time1(tot1)-time1(1)+1;
est = zeros(eps,np1)+110;
est(inNa>0,:) = evalPol('data2Splines.bin',time1(1),time1(tot1));
