%TO: for strat={gcv, lcv, gcv-activelearning, lcv-activelearning},  for
%data A/B/D/E with 12 pts, for cost = {1.0}: get the estimated
%samplings. get a more fine grained estimate

global topLevelCost;
global DEBUG;


DEBUG = 3;
load SimData;

dSets = {dataA, dataB, dataD, dataE};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE'};

costs = [1.0];
costNames = {'1_0'};

strats = {'gcv', 'lcv-smart', 'gcv-activelearning', 'lcv-activelearning'};
stratTitles = {'gcv','lcv','gcv+al','lcv+al'};

maxPoints = 231;

for j=1:length(dSets)
  dN = dSetNames{j};
  
  rName = ['test2_rnd_' dN];
  R = load(rName);
  classes = 3;
  numGenes = size(dSets{j},1);
  n = numGenes/classes;
  inNa = [ones(1,n) 2*ones(1,n) 3*ones(1,n)];
  for r=1:size(R.all_finalT,1)
    t = R.all_finalT(r,:);
    estR(r,:,:) = test3_fillInEstimate( dSets{j}, t', classes, inNa, R.all_gcvNumCntrlPts(r),maxPoints);
  end
  routfname = ['test3_rnd_fine_' dN]
  save(routfname, 'classes', 'inNa', 'estR');
  
  for i=1:length(costs)
    for k=1:length(strats)
      dname = ['27sep3pm_' dN '_st5_end12_' strats{k} '_c_' costNames{i}];
      
      Dfile = load(dname);
      
      est = test3_fillInEstimate( dSets{j}, Dfile.finalT, Dfile.classes, ...
				  Dfile.Na, Dfile.numCntrlPts, ...
				  maxPoints);
      
      fname = ['test3_fine_' dN '_' strats{k} '_c_' costNames{i}]
      save(fname, 'est', 'maxPoints');
    end
  end
  clear est estR;
end

