%TO: for dataA/D/E create 150x231 matrix with values that are more
%finely sampled than dataA/D/E


load SimData;

m = 10;
f = 1.0/m;
rf = (m-1)*f;

T0 = 24;
T = T0*m;
times = 0:T-1;

% the max is typically 1. and the std dev is always 0.2
rng = 1;
stdDev = 0; % NOTE: we keep the ideal. so no deviation. 0.2;

totalSize = 150;
numClusters = 3;
clusterSize = totalSize/ numClusters;

% dataA


a1 = [0:f:11+rf  0:f:11+rf] * 2 *pi / 12; % 0..2pi over 2 cycles
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = [3:f:11+rf 0:f:11+rf 0:f:2+rf] * 2 * pi/ 12; %0..2pi over 2 cycles, with phase
                                   %pi/2
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fA = [X1; X2; X3];


% dataD
a1 = [zeros(1,6*m) 0:f:11+rf zeros(1,6*m)] * 2 *pi / 12; % 0..2pi over 1 cycle
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

X2 = -X1;
K2 = -K1;

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fD = [X1; X2; X3];

% dataE
a1 = [0:f:11+rf zeros(1,12*m)] * 2 * pi / 12; % will use sin(0) = 0
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = -a1;
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fE = [X1; X2; X3];


% splice in dataA/D/E where they should be
I = 1 + m*(0:T0-1);
fA(:,I) = dataA(:,:);
fD(:,I) = dataD(:,:);
fE(:,I) = dataE(:,:);

fineA(:,:) = fA(:,1:231);
fineD(:,:) = fD(:,1:231);
fineE(:,:) = fE(:,1:231);

save FineGrainData fine*;
