load SimData;
load SimIdeal;

iSets = {idealA, idealB, idealD, idealE, idealG, idealH, idealI};
dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};

for j=[2 4]%1:length(dSets)
  dF = ['test4_' dSetNames{j} ];
  rF = ['test4_rnd_' dSetNames{j} ];
  
  D = load(dF);
  R = load(rF);
  
  errMetric = zeros(1,24);
  errDesc = 'deviation from real data';
  
  fprintf(1,'%s:           LCV+AL  vs. RANDOM :\n', dSetNames{j});
  fprintf(1,'==================================\n');
  fprintf(1,'\t threshold: %.3f\n',D.threshold);
  fprintf(1,'\t Error (%s) behavior with # of timepoints:\n',errDesc);
  
  rN = D.numFinalSamples;
  
  for i=5:24
    %LCV+AL
    if (i <= rN)
      estD(:,:) = D.gcvC1(i,:,:);
      eD1 = estD - iSets{j};%dSets{j};
      eD2 = (sum(sum(eD1.^2,1)) / (size(eD1,1)*size(eD1,2)));
      errMetric(i) = eD2;
      
      fprintf(1,'%10s: %3d%10s %-20.3f\n','LCV+AL',i,'', ...
	      errMetric(i));
    end
    
    %RANDOM
    sR = sum(R.all_finalT,2);
    iR = sR>i;
    x1 = 1:length(sR);
    cR = x1(logical(iR));
    if(length(cR)>0)
      for k=1:length(cR)
	estR(:,:) = R.all_gcvC1(cR(k),i,:,:);
	eR1 = estR - iSets{j};%dSets{j};
	eR2 = (sum(sum(eR1.^2,1)) / (size(eR1,1)*size(eR1,2)));
	errRand(k) = eR2;
      end
      fprintf(1,'%10s: %3d Error: (mean=%5.3f; min=%5.3f median=%5.3f max=%5.3f)\n', 'RANDOM',i, mean(errRand), min(errRand), median(errRand), max(errRand));
    end
    fprintf(1,'\n\n');
  end
end
