function [dIdx,dTrueErr,dErrMetric,rIdx,rTrueErr,rErrMetric] = ...
    test4_anlyz_trueErrvsErrMetric(dSetIdx, trueErrThreshold, DvsTrueErr, ...
				   RvsTrueErr, dStopAt, rStopAt, errMetricDesc)

load SimData;
load SimIdeal;

iSets = {idealA, idealB, idealD, idealE, idealG, idealH, idealI};
dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};

j=dSetIdx;
dF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_' dSetNames{j} ];
rF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_rnd_' dSetNames{j} ];

D = load(dF);
R = load(rF);


if (j==2)
  D.err(6)=4.87;
  D.err(14) = 3.4;
end

if (j==4)
  D.err(8)=3.60;
end

dN = D.numFinalSamples;

if (length(strfind(errMetricDesc,'GCV Error'))>0 | ...
    length(strfind(errMetricDesc,'Error Measure = Conf. Area using GCV CIs'))>0  | length(strfind(errMetricDesc,'GCV-error'))>0)
  D_ERR = D.err;
  R_ERR = R.all_err;
end

if (strfind(errMetricDesc,'GCV Error with NumCPs'))
  c = [8 12 8 10 10 10 12];
  D_ERR = ones(1,24)*1e4;
  R_ERR = ones(10,24)*1e4;
  
  for i=5:dN
    D_ERR(i) = D.err(i) + max([0,c(j)-D.gcvCntrlPts(i)])/3;%(20.0/ (D.gcvCntrlPts(i)-3));
  end

  for i=1:10
    z1(:,:)=R.all_sampledPoints(i,:,:);
    z2 = sum(z1,2);
    l = 1:24;
    rN = max(l(z2~=0));
    for k=5:rN
      R_ERR(i,k) = R.all_err(i,k)+ max([0,c(j)-R.all_gcvCntrlPts(i,k)])/3;%(20.0/ (R.all_gcvCntrlPts(i,k)-3));
    end
  end
end

if (strfind(errMetricDesc,'Curve Sigma'))
  D_ERR = ones(1,24)*1e4;
  R_ERR = ones(10,24)*1e4;
  
  for i=5:dN
    c1(:,:) = D.gcvC1(i,:,:);
    na = D.gcvNa(i,:);
    x1 = c1;
    for j=1:max(na)
      clear y1;
      l = 1:length(na);
      jidx = l(na==j);
      y1(:,:) = c1(jidx',:);
      y2 = mean(y1,1);
      y1 = repmat(y2,length(jidx),1);
      x1(jidx,:) = y1;
    end
    diff1 = c1-x1;
    D_ERR(i) = std(diff1(:));
  end
  
  for i=1:10
    z1(:,:)=R.all_sampledPoints(i,:,:);
    z2 = sum(z1,2);
    l = 1:24;
    rN = max(l(z2~=0));
    for k=5:rN
      c1(:,:) = R.all_gcvC1(i,k,:,:);
      na = R.all_gcvNa(i,k,:);
      x1 = c1;
      for j=1:max(na)
	clear y1 ;
	l = 1:length(na);
	jidx = l(na==j);
	y1(:,:) = c1(jidx,:);
	y2 = mean(y1,1);
	y1 = repmat(y2,length(jidx),1);
	x1(jidx,:) = y1;
      end
      diff1 = c1-x1;
      R_ERR(i,k) = std(diff1(:));
    end
  end

end

if (strfind(errMetricDesc,'Worst Cluster Sigma'))
  D_ERR = ones(1,24)*1e4;
  R_ERR = ones(10,24)*1e4;
  
  for i=5:dN
    c1(:,:) = D.gcvC1(i,:,:);
    na = D.gcvNa(i,:);
    x1 = c1;
    clErr = [];
    for j=1:max(na)
      clear y1 diff2;
      l = 1:length(na);
      jidx = l(na==j);
      y1(:,:) = c1(jidx',:);
      y2 = mean(y1,1);
      y1 = repmat(y2,length(jidx),1);
      x1(jidx,:) = y1;
      diff2(:,:) = c1(jidx,:)-x1(jidx,:);
      clErr(end+1) = std(diff2(:));
    end
    D_ERR(i) = max(clErr);
  end
  
  for i=1:10
    z1(:,:)=R.all_sampledPoints(i,:,:);
    z2 = sum(z1,2);
    l = 1:24;
    rN = max(l(z2~=0));
    for k=5:rN
      c1(:,:) = R.all_gcvC1(i,k,:,:);
      na = R.all_gcvNa(i,k,:);
      x1 = c1;
      clErr = [];
      for j=1:max(na)
	clear y1 diff2;
	l = 1:length(na);
	jidx = l(na==j);
	y1(:,:) = c1(jidx,:);
	y2 = mean(y1,1);
	y1 = repmat(y2,length(jidx),1);
	x1(jidx,:) = y1;
	diff2(:,:) = c1(jidx,:)-x1(jidx,:);
	clErr(end+1) = std(diff2(:));
      end
      R_ERR(i,k) = max(clErr);
    end
  end

end

dTrueErrIdx = DvsTrueErr(:,1);
rTrueErrIdx = RvsTrueErr(:,1);
alld=1:length(dTrueErrIdx);
allr=1:length(rTrueErrIdx);

dIdx = [];
dTrueErr = [];
dErrMetric = [];
for i=5:dN
  if (sum(dTrueErrIdx==i)>0)
    dIdx(end+1) = i;
    dx1 = alld(logical(dTrueErrIdx==i));
    dTrueErr(end+1) = DvsTrueErr(dx1,2);
    dErrMetric(end+1) = D_ERR(i);
  end
end

rIdx=[];
rTrueErr = [];
rErrMetric = [];
for i=5:22
  rx1 = R_ERR(:,i);
  rx2 = rx1(rx1<100);
  rer1 = mean(rx2);
  if (sum(rTrueErrIdx==i)>0 & length(rx2)>3)
    rIdx(end+1) = i;
    rx3 = allr(logical(rTrueErrIdx==i));
    rTrueErr(end+1) = RvsTrueErr(rx3,2);
    rErrMetric(end+1) = rer1;
  end
end
