%TO: for datasets={dataA,dataB,dataD,dataE,dataG,dataH} with cost=1.0,
%run with threshold = 0.85 * 0.8 * 0.2 * 23 

global topLevelCost;
global DEBUG;

topLevelCost=1;
DEBUG = 1.5;
load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};

startT = [1 6 12 18 24]';
allTimes = [1:24]';
classes = 3;
strategy = 'random';
sigma = 0.2;

numRandomTries = 10;

threshold = 2.5;%0.85 * (0.8 * 0.2) * (24-1);

global imposeGCVcpLimit;
imposeGCVcpLimit=1;

% on np-g5  for j=2:length(dSets)
for j=[1 7]%5:length(dSets)
     [numGenes, numTotalSampled] = size(dSets{j});
     initialN = size(startT,1);
     k = initialN;
     
     all_sampledPoints= zeros(numRandomTries,numTotalSampled,numTotalSampled);
     all_sampledPoints(:,initialN, startT) = 1;
     
     all_bestC1 = zeros(numRandomTries,numTotalSampled, numGenes, numTotalSampled);
     all_bestNa = zeros(numRandomTries,numTotalSampled, numGenes);
    
     all_gcvCntrlPts = zeros(numRandomTries,numTotalSampled,1);
     all_lcvCntrlPts = zeros(numRandomTries,numTotalSampled, numTotalSampled);
    
     all_gcvC1 = zeros(numRandomTries,numTotalSampled, numGenes, numTotalSampled);
     all_gcvNa = zeros(numRandomTries,numTotalSampled, numGenes);
     all_gcvSig = zeros(numRandomTries,numTotalSampled,1);

     
     all_numCntrlPts = zeros(1,numRandomTries);
     all_finalT = zeros(numRandomTries, numTotalSampled);
     all_finalErr = zeros(1,numRandomTries);
     all_numFinalSamples = zeros(1,numRandomTries);
     
     initCI = ones(1,24)*-1;  % -1 is pretty much an imposs value for CI
     
     all_ci = zeros(numRandomTries,numTotalSampled,numTotalSampled);
    
     all_err = 10000 * ones(numRandomTries,numTotalSampled);

     D = dSets{j};

     fname = ['test4_rnd_' dSetNames{j} ]

     for r=1:numRandomTries

       r
%       try 
	 k=initialN;
	 T = startT;
	 
	 lastErr = 0;
	 currErr = 0;
	 
	 prevGcvCntrlPts = 0;
	 while ( length(T) < 22 & (k<(initialN+2) | currErr>threshold))% | lastErr>threshold))
      
	   all_sampledPoints(r,k,T) = 1;
      
	   [gcvI, Agcv, C1gcv, C2gcv, Na_gcv, gcvScore, sig, gcv_alli, ...
	    gcv_allC1, gcv_allNa, gcv_allSig] = findLambdaG(D, T, allTimes, classes, prevGcvCntrlPts-1, 0, prevGcvCntrlPts+4);
	   
	   dummy=1;
	   
	   diagAgcv=sum(diag(Agcv)), sqrtdiagAgcv=sum((diag(Agcv)).^(0.5)), gcvI
	   
	   [xlcvCntrlPts, lcv_Scores] = lcv(D, T, allTimes, gcvI, gcv_alli, gcv_allC1, gcv_allNa);
	   
	   fprintf(1,'std dev.: %f\n',sqrt(sig));
	   
	   all_gcvCntrlPts(r,k) = gcvI;
	   all_lcvCntrlPts(r,k,T) = xlcvCntrlPts;
	   
	   prevGcvCntrlPts = gcvI;
	   
	   all_gcvC1(r,k,:,:) =C1gcv;
	   all_gcvNa(r,k,:) = Na_gcv;
	   all_gcvSig(r,k) = sig;
      	   
	   xfinalCI = initCI;
	   
	   % find using GCV error
	   for i=1:length(T)
	     s_i = getS( allTimes(T), gcvI);%xlcvCntrlPts(i));
	     A_i = s_i * pinv(s_i);
	     xfinalCI(T(i)) = CI(A_i(i,i), sqrt(sig));
	   end	
      
	   lastErr = currErr;
	   
	   currErr = 0;
	   for i=1:length(T)-1
	     ci1 = xfinalCI( T(i) );
	     ci2 = xfinalCI( T(i+1) );
	     currErr = currErr+ (ci1+ci2) * 0.5 * (allTimes(T(i+1)) - allTimes(T(i)));
	   end
	   all_ci(r,k,:) = xfinalCI;
	   all_err(r,k) = currErr;
	   

	   A= [1:24]';
	   x1 = setdiff(A,T);
	   i1 = randperm( length(x1) );
	   nextI = x1( i1(1) );
	   
	   oldT = T;
	   a = T(T<nextI);
	   b = T(T>nextI);                  
	   T = [a; nextI; b];
	   
	   k = k+1;
	   
	   T', nextI, currErr, threshold 

	   all_numCntrlPts(r) = k-1;
	   interrupted=1;
	   save(fname,'all_numCntrlPts', 'threshold', 'all_sampledPoints','all_gcvCntrlPts','all_lcvCntrlPts','all_gcvNa','all_gcvC1','all_bestNa','all_bestC1', 'all_ci','all_err','D','allTimes','startT','classes','strategy','interrupted');

	   
	 end
	 
	 %[yC1,yC2,yNa, sig2] = contRep(D, D, allTimes', allTimes', all_gcvCntrlPts(r,k-1)-2, classes);
	 
	 %all_bestC1(r,k,:,:) = yC2(:,allTimes-allTimes(1)+1);
	 %all_bestNa(r,k,:) = yNa;
	 

	 all_numCntrlPts(r) = gcvI;
	 all_finalT(r,oldT') = ones(size(oldT'));  
	 all_finalErr(r) = currErr;
	 all_numFinalSamples(r) = k -1;
	 
	 save(fname,'all_finalT','all_finalErr','all_numCntrlPts', 'threshold', ...
	      'all_sampledPoints','all_gcvCntrlPts','all_lcvCntrlPts', ...
	      'all_gcvNa','all_gcvC1','all_bestNa','all_bestC1', 'all_ci','all_err','D','allTimes','startT','classes','strategy');
	 
%       catch
%	 % grab the error that got us here
%	 [err, id] = lasterr;
%	 fprintf(1,'Skipping over this random-run for dataset %s because of error "%s"\n', dSetNames{j},err);
%	 continue;
%       end
    end
     
end
