%TO: for datasets={dataA,dataB,dataD,dataE,dataG,dataH} with cost=1.0,
%run with threshold

global topLevelCost;
global DEBUG;
global imposeGCVcpLimit;
global adaptiveCostStrategy;

realTopLevelCost = 1;
topLevelCost = realTopLevelCost;
imposeGCVcpLimit = 1;
adaptiveCostStrategy = 1;

DEBUG = 3;
load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};

startT = [1 6 12 18 24]';
allTimes = [1:24]';
classes = 3;
strategy = 'lcv-activelearning';
sigma = 0.2;

threshs = [2.5, 2.2, 2.5, 2.5, 2.5, 2.2, 2.2];



% on TERN: for j=[2 3 5 6 7]%1:length(dSets)%1:length(dSets)
for j=[4]%1:length(dSets)%1:length(dSets)
  threshold = threshs(j);%2.5;%0.85 * (0.8 * 0.2) * (24-1);
  try  
    [numGenes, numTotalSampled] = size(dSets{j});
    initialN = size(startT,1);
    k = initialN;
    
    sampledPoints= zeros(numTotalSampled,numTotalSampled);
    sampledPoints(initialN, startT) = 1;
    
    bestC1 = zeros(numTotalSampled, numGenes, numTotalSampled);
    bestNa = zeros(numTotalSampled, numGenes);
    
    gcvCntrlPts = zeros(numTotalSampled,1);
    lcvCntrlPts = zeros(numTotalSampled, numTotalSampled);
    
    gcvC1 = zeros(numTotalSampled, numGenes, numTotalSampled);
    gcvNa = zeros(numTotalSampled, numGenes);
    gcvSig = zeros(numTotalSampled,1);
    
    ci = zeros(numTotalSampled,numTotalSampled);
    
    err = 10000 * ones(1,numTotalSampled);
    
    T = startT;
    
    lastErr = 0;
    currErr = 0;
    
    D = dSets{j};

    fname = ['test4_' dSetNames{j} ];
    
    prevGcvCntrlPts = 0;
    
    while ( length(T) < 20 & (k<(initialN+2) | currErr>threshold))% | lastErr>threshold))
      
      sampledPoints(k,T) = 1;
      
      [nextI, xnumCntrlPts, xlcvCntrlPts, xfinalCI, xC1, xNa, sig] = pickNext( ...
	  D(:,T), T, allTimes, classes, strategy, sigma, prevGcvCntrlPts);
      
      gcvCntrlPts(k) = xnumCntrlPts;
      lcvCntrlPts(k,T) = xlcvCntrlPts;
      
      gcvC1(k,:,:) =xC1;
      gcvNa(k,:) = xNa;
      gcvSig(k) = sig;
      
      %[yC1,yC2,yNa, sig2] = contRep(D, D, allTimes', allTimes', gcvCntrlPts(k)-2, classes);
      
      %bestC1(k,:,:) = yC2(:,allTimes-allTimes(1)+1);
      %bestNa(k,:) = yNa;
      
      ci(k,:) = xfinalCI;
      
      % score each cluster in terms of error (using gcv error)
      err(k)=0;
      nT = length(T);
      CIgcv = zeros(1,length(allTimes));
      for r=1:nT
	s_r = getS( allTimes(T), xnumCntrlPts);
	A_r = s_r * pinv(s_r);
	CIgcv(T(r)) = CI(A_r(r,r), sqrt(sig));
      end
  
      currCIsum = 0;
      for r=1:nT-1
	ci1 = CIgcv( T(r) );
	ci2 = CIgcv( T(r+1) );
	currCIsum = currCIsum+ (ci1+ci2) * 0.5 * (allTimes(T(r+1)) - allTimes(T(r)));
      end
      err(k) = currCIsum;
      
      
      lastErr = currErr;
      currErr = err(k);
      
      oldT = T;
      a = T(T<nextI);
      b = T(T>nextI);
      T = [a; nextI; b];
      
      T', nextI, currErr, threshold 

      if (imposeGCVcpLimit)
	prevGcvCntrlPts = xnumCntrlPts
      else
	prevGcvCntrlPts = 0;
      end
      
      if (adaptiveCostStrategy)
	gcvCntrlPts(k),gcvCntrlPts(k-1)
	if (gcvCntrlPts(k)==gcvCntrlPts(k-1))
	  topLevelCost = max([ 0.7*realTopLevelCost, 0.9 * topLevelCost])
%	  if (strfind(strategy,'lcv-al-cluster'))
%	    topLevelCost = realTopLevelCost * 0.7;
%	  else
%	    topLevelCost = realTopLevelCost * 0.8;
%	  end
	else
	  topLevelCost = realTopLevelCost
	end
      end

      k = k+1;
      
      numCntrlPts = k-1;
      interrupted=1;
      save(fname,'numCntrlPts', 'threshold', 'sampledPoints','gcvCntrlPts','lcvCntrlPts','gcvNa','gcvC1','bestNa','bestC1', 'ci','err','D','allTimes','startT','classes','strategy','interrupted');

      
    end
    
    numCntrlPts = xnumCntrlPts;
    finalT = oldT;  
    finalCI = xfinalCI;
    finalErr = finalCI(1);
    numFinalSamples = k -1;
    
    fname = ['test4_' dSetNames{j} ];
    save(fname,'finalT','finalCI','finalErr','numCntrlPts', 'threshold', ...
	 'sampledPoints','gcvCntrlPts','lcvCntrlPts','gcvNa','gcvC1','bestNa','bestC1', 'ci','err','D','allTimes','numFinalSamples','startT','classes','strategy');
  catch
    % grab the error that got us here
    [err, id] = lasterr;
    fprintf(1,'Skipping over this dataset %s because of error "%s"\n', dSetNames{j},err);
    continue;
  end
  
end
