function test4_visualize2(data,lcvalFile,numtimepts,rndfile,rndIndx1,rndIndx2,rndIndx3,dataName, colTitles,figTitle)

lcvalS = load(lcvalFile);
rndF = load(rndfile);

if (size(data,1) ~= 150 | size(data,2) ~= 24)
  error('Need 150 genes x 24 expmts');
end
numGenes = 150;
N=24;
sigma = 0.2;
errMagnify = 10;

cl1 = 1:50;
cl2 = 51:100;
cl3 = 101:150;

%in each cluster we pick about 10 samples to just draw in background.
%these 10 are their indices
rndprm1 = randperm(50); %50 elmts per cluster
idx1 = rndprm1(10);

Cols = 6;

%4xCols matrix of figures 
% first col is ideal i.e. real function used
% 2nd col is gcv
% 3rd col is lcv
% 4th col is gcval
% last col is actual i.e. using all timepointsreal function used


%plot ideal

% 1st row, 1st col is empty
idealBG = [1 1 0.6]; %light yellow
%sphdl = subplot(4,Cols,1);
%hold on;
%set(sphdl,'Color',idealBG);

% 2nd row, 1st col is cluster1
sphdl = subplot(4,Cols,Cols+1);
d1 = data(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;
set(sphdl,'Color',idealBG);

% 3rd row, 1st col is cluster 2
sphdl = subplot(4,Cols,2*Cols +1);
d2 = data(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;
set(sphdl,'Color',idealBG);

% 3rd row, 1st col is cluster 3
sphdl = subplot(4,Cols,3*Cols+1);
d3 = data(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;
set(sphdl,'Color',idealBG);


%fix axes:
a11 = [1 2 3]*Cols + 1;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end

%plot ideal done


%plot best data
allTimes = 1:N;%[1:2:N-1 N];
%[bestC1,bestC2,bestNa] = contRep(data(:,allTimes),data(:,allTimes),allTimes,allTimes,lcvalS.numCntrlPts-2, 3);
bestC1(:,:) = lcvalS.gcvC1(lcvalS.numFinalSamples,:,:);
bestNa = lcvalS.gcvNa(lcvalS.numFinalSamples,:);

bErr = abs(bestC1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,lcvalS.gcvCntrlPts(numtimepts));
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sigma;

% 1st row, 5th col is empty
bestBG = [0.9 0.9 1]; %purplish
clear d1, t1;

sphdl = subplot(4,Cols,Cols);
title('With all samples','FontSize',11,'FontWeight','bold')
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
for i=1:N
  plotErrorBar(i,0,bci1(i),'r',1);
end
set(sphdl,'Color',bestBG);


% 2nd row, 5th col is cluster1
sphdl = subplot(4,Cols,2*Cols);
d1 = bestC1(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;
set(sphdl,'Color',bestBG);

% 3rd row, 5th col is cluster 2
sphdl = subplot(4,Cols,3*Cols);
d2 = bestC1(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;
set(sphdl,'Color',bestBG);

% 3rd row, 5th col is cluster 3
sphdl = subplot(4,Cols,4*Cols);
d3 = bestC1(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;
set(sphdl,'Color',bestBG);

%fix axes:
a11 =[2 3 4]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,Cols);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=Cols*[1 2 3 4]
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = lcvalS.gcvCntrlPts(numtimepts);
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = Cols*[2 3 4];
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=allTimes
    plot([i i],[ymin tx(j,i)],'m');
  end 
end



%plot gcv data
gC1(:,:) = lcvalS.gcvC1(numtimepts,:,:);
bErr = abs(gC1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,lcvalS.gcvCntrlPts(numtimepts));
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 2nd col is empty


sphdl = subplot(4,Cols,2);
% plot errors
title(colTitles{1},'FontSize',11,'FontWeight','bold');
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,lcvalS.finalCI(i)/ max(size(lcvalS.finalT)),'r',1); %bci1(i),'r',1);
%end



% 2nd row, 2nd col is cluster1
sphdl = subplot(4,Cols,2+Cols);
d1(:,:) = gC1(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 2nd col is cluster 2
sphdl = subplot(4,Cols,2+2*Cols);
d2(:,:) = gC1(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 2nd col is cluster 3
sphdl = subplot(4,Cols,2+3*Cols);
d3(:,:) = gC1(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 2+Cols*[1 2 3];
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,1+1);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=2+ [ 1 2 3]*Cols
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = lcvalS.gcvCntrlPts(numtimepts);
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 2;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = ...
	 axs1(4);
  nT = lcvalS.allTimes( logical(lcvalS.sampledPoints(numtimepts,:)));
  for i=1:length(nT)
    plot([nT(i) nT(i)], [ymin tx(j,nT(i))],'m');
  end 
end

rT = sum(rndF.all_finalT,2);

%plot lcv-naive data
rK = min([ numtimepts, rT(rndIndx1)]);

r1C1(:,:) = rndF.all_gcvC1(rndIndx1, rK, : , :);
r1times1= rndF.all_sampledPoints(rndIndx1,rK,:);
r1FinalT = rndF.allTimes( logical(r1times1));

bErr = abs(r1C1    -data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,rndF.all_gcvCntrlPts(rndIndx1,rK));
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 3rd col is empty


sphdl = subplot(4,Cols,3);
title(colTitles{2},'FontSize',11,'FontWeight','bold');
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,lcvS.finalCI(i)/ max(size(lcvS.finalT)),'r',1); %bci1(i),'r',1);
%end


% 2nd row, 3rd col is cluster1
sphdl = subplot(4,Cols,3+1*Cols);
d1(:,:) = r1C1(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 2
sphdl = subplot(4,Cols,3+2*Cols);
d2(:,:) = r1C1(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 3
sphdl = subplot(4,Cols,3+3*Cols);
d3(:,:) = r1C1(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 3+ [1 2 3]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,3);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=[ 1 2 3]*Cols + 3;
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = rndF.all_gcvCntrlPts(rndIndx1,rK);
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 3;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = ...
	 axs1(4);
  for i=1:length(r1FinalT)
    plot([r1FinalT(i) r1FinalT(i)], [ymin tx(j,r1FinalT(i))],'m');
  end 
end

%plot gcval data
rK = min([ numtimepts, rT(rndIndx2)]);

r2C1(:,:) = rndF.all_gcvC1(rndIndx2, rK, : , :);
r2times1= rndF.all_sampledPoints(rndIndx2,rK,:);
r2FinalT = rndF.allTimes( logical(r2times1));
r2numCntrlPts = rndF.all_gcvCntrlPts(rndIndx2,rK);


bErr = abs(r2C1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,r2numCntrlPts);
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 3rd col is empty


sphdl = subplot(4,Cols,4);
title(colTitles{3},'FontSize',11,'FontWeight','bold');
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,gcvalS.finalCI(i)/ max(size(gcvalS.finalT)),'r',1); %bci1(i),'r',1);
%end


% 2nd row, 3rd col is cluster1
sphdl = subplot(4,Cols,4+1*Cols);
d1(:,:) = r2C1(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 2
sphdl = subplot(4,Cols,4+2*Cols);
d2(:,:) = r2C1(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 3
sphdl = subplot(4,Cols,4+3*Cols);
d3(:,:) = r2C1(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 4+ [1 2 3]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,4);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=[ 1 2 3]*Cols + 4
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = r2numCntrlPts;
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 4;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=1:length(r2FinalT)
    plot([r2FinalT(i) r2FinalT(i)], [ymin tx(j,r2FinalT(i))],'m');
  end 
end


%fix y-limits for the top row
a11 = 2:Cols;
for i=1:max(size(a11))
  sphdl = subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -0.75 0.75]);
  set(sphdl,'XTickLabels','');
  set(sphdl,'YTickLabels','');
end

rK = min([ numtimepts, rT(rndIndx3)]);

r3C1(:,:) = rndF.all_gcvC1(rndIndx3, rK, : , :);
r3times1= rndF.all_sampledPoints(rndIndx3,rK,:);
r3FinalT = rndF.allTimes( logical(r3times1));
r3numCntrlPts = rndF.all_gcvCntrlPts(rndIndx3,rK);

bErr = abs(r3C1-data) / numGenes;
b1 = sum(bErr,1)*errMagnify;

bS = getS(1:N,r3numCntrlPts);
bA = bS*pinv(bS);
bci1 = sqrt(diag(bA,0));
bci1 = bci1*sqrt(sigma);

% 1st row, 3rd col is empty


sphdl = subplot(4,Cols,5);
title(colTitles{4},'FontSize',11,'FontWeight','bold');
% plot errors
%plot(b1-mean(b1),'Color',[0 0.5 0],'Linewidth',2); %middle at 0
hold on;
%plot conf intervals
%for i=1:N
%  plotErrorBar(i,0,lcvalS.finalCI(i)/ max(size(lcvalS.finalT)),'r',1); %bci1(i),'r',1);
%end


% 2nd row, 3rd col is cluster1
sphdl = subplot(4,Cols,5+1*Cols);
d1(:,:) = r3C1(cl1,:);
t1 = mean(d1,1);
plot(t1,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 2
sphdl = subplot(4,Cols,5+2*Cols);
d2(:,:) = r3C1(cl2,:);
t2 = mean(d2,1);
plot(t2,'b','Linewidth',3);
hold on;

% 3rd row, 3rd col is cluster 3
sphdl = subplot(4,Cols,5+3*Cols);
d3(:,:) = r3C1(cl3,:);
t3 = mean(d3,1);
plot(t3,'b','Linewidth',3);
hold on;

%fix axes:
a11 = 5+ [1 2 3]*Cols;
for i=1:max(size(a11))
  subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -1.5 1.5]);
end
subplot(4,Cols,4);
axs1 = axis;
axis([0 26 axs1(3) axs1(4)]);

%plot control bars
for j=[ 1 2 3]*Cols + 5
  subplot(4,Cols,j);
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  n1 = r3numCntrlPts;
  x1 = (N-1)/(n1-2);
  for i=0:n1-2
    plot([1+i*x1 1+i*x1],[ymin ymax],':');
  end
end

% plot the supports from points at which we sampled
tx(1,:) = t1;tx(2,:) = t2;tx(3,:) = t3;
j1 = [1 2 3]*Cols + 5;
for j=1:max(size(j1))
  subplot(4,Cols,j1(j));
  hold on;
  axs1 = axis; xmin = axs1(1);xmax= axs1(2);ymin = axs1(3);ymax = axs1(4);
  for i=1:max(size(r3FinalT))
    plot([r3FinalT(i) r3FinalT(i)], [ymin tx(j,r3FinalT(i))],'m');
  end 
end


%fix y-limits for the top row
a11 = 2:Cols;
for i=1:max(size(a11))
  sphdl = subplot(4,Cols,a11(i));
  %axis(axs1);
  axis([0 26 -0.75 0.75]);
  set(sphdl,'XTickLabels','');
  set(sphdl,'YTickLabels','');
end

figure(gcf);
gtext(['For dataset ' dataName ' with ' figTitle],'FontSize', 11,'FontWeight','bold');
