function G = findGamma(Y,AllS,Mue,num,Theta,sig,grid,clNum,prob);

% Y - Y a matrix, each column corresponds to a gene.
% AllS - Collection of matrices for each gene
% Gamma - Matrix of the currently estimated Gammas
% X - indicates to which class the gene belongs
% Theta - the covariance matrix
% sig - the variance
% Mue - Class averages
% grid - the numbewr of grid points
% clNum - number of classes
% prob - the probabilty for each class

G = zeros(grid,num);
for i=1:num,
  curS = AllS(:,:,i);
  for j=1:clNum,
     G(:,i) = G(:,i) + (1/clNum)*pinv(curS'*curS) ...
            * curS' * (Y(:,i)-curS*(Mue(:,j)));
  end
end
