function  [Theta,inp,avg,Gamma,sig] = interK(Nv2,Na,grid,eps,times,reRun,startName);
% Nv2 - Same as Nv2 in inter.m
% Na - cluster assignment for included genes (use the 'Na' output of 
%       'inter.m' for the two sets as the input here). 
% grid - number of grid points (same as before)
% eps - the difference for convergence
% times - the times of the different experiments
% startName - initial for the output file name

  lastwarn('');
%  lastwarning('');

  clNum = max(Na);
  Y1 = Nv2;
  F1 = find(Na > 0);
  [totG,expNum] = size(Y1); 
  Y = Y1(F1,:);
  c = Na(F1);
  geneNum = size(Y,1);
  grid = grid + 2;
  gridVals = [0:grid-1];
  t1 = [1:expNum];
  t1 = (times-times(1))*(grid-3)/(times(expNum)-times(1)) + 1;
  t = repmat(t1',1,geneNum);
  Y = Y';
  numVals = sum(Y < 90,1); 
  t(Y > 90) = 0;
  Y(Y > 90) = 0;
  inp = Y;
% numVals is the number of observed values for each gene
  AllS = zeros(expNum,grid,geneNum); 
% spline matrix with all coef'
 origS = createSK(t1,gridVals,grid,expNum);
 for i=1:geneNum,
   AllS(:,:,i) = createSK(t(:,i),gridVals,grid,expNum);
 end
 bestVal = -10000;
 for rer=1:reRun,
   Gamma = zeros(grid,geneNum);
   Theta = ones(grid,grid,clNum);
   for i=1:clNum,
	Theta(:,:,i) = diag(ones(grid,1)*1,0);
   end
   Mue = zeros(grid,clNum);
   sig = .1; 
   diff = 1000000;
   pre = -10000000;
   st = 1; 
   while diff > eps
     Mue = findMueK(inp,AllS,Gamma,geneNum,clNum,grid,expNum,c);
     sig = findSigmaK(inp,AllS,Mue,Gamma,geneNum,numVals,clNum,c,Theta,sig);
     if sig < .01
       sig = .01;
     end     
     Theta = findThetaK(Gamma,AllS,sig,geneNum,clNum,c,st,Theta);
     st = st + 1;
     Gamma = findGammaK(inp,AllS,Mue,geneNum,Theta,sig,grid,clNum,c);
     cur = compLogK(inp,AllS,Gamma,Mue,Theta,geneNum,sig,numVals,...
		   clNum,grid,c);
     diff = abs(cur - pre);
     pre = cur;
     st = st + 1;
     %[wrnmsg,wrnid] = lastwarning();
     [wrnmsg,wrnid] = lastwarn;
     if (strfind(wrnid,'MATLAB:singularMatrix'))
       error('interK.m:SingularMatrix','interK.m:SingularMatrix');
     end
   end
   if cur > bestVal
     saveMue = Mue;
     saveGamma = Gamma;
     bestVal = cur;
   end
 end
 Mue = saveMue;
 Gamma = saveGamma;
 curves = zeros(grid-3,4,geneNum);
 cP1 = zeros(geneNum,grid);
 cP2 = zeros(geneNum,grid);
 pl = 1;
 for i=1:geneNum,
     curves(:,:,i) = findCurveK(Mue(:,c(i)),Gamma(:,i),grid);
 end
 fileName = [startName 'Splines.bin'];
 fid = fopen(fileName,'wb');
 fwrite(fid,size(curves),'int');
 fwrite(fid,curves,'float');
 fclose(fid);
 avg = zeros(clNum,expNum);
 for i=1:clNum,
   avg(i,:) = (origS*Mue(:,i))';
 end
